const nsIFilePicker = Components.interfaces.nsIFilePicker;
var reminderFox_mPositionMax;
function reminderFox_loadOptions() {

	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"]. 
				getService(Components.interfaces.nsIPrefService). 
				getBranch(REMINDER_FOX_PREF + ".");
	
	var showStatus = true;			
	try {
		showStatus = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
	} catch(e) {
	}			
	document.getElementById("reminderFox-statustext").setAttribute("checked", showStatus);

	var showRemindersInTooltip = true;			
	try {
		showRemindersInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showRemindersTooltip").setAttribute("checked", showRemindersInTooltip);

	var showTodosInTooltip = true;			
	try {
		showTodosInTooltip = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
	} catch(e) {
	}			
	document.getElementById("reminderFox-showTodosTooltip").setAttribute("checked", showTodosInTooltip);
	
	var upcomingDays = "0";
	try {
		upcomingDays = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF);
	} catch(e) {
	}
	document.getElementById("remindersUpcomingDays").setAttribute("value", upcomingDays);


	var defaultEditType = REMINDER_FOX_DEFAULT_EDIT_DEFAULT;			
	try {
		defaultEditType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
	} catch(e) {
	}	
	
	var defaultEdit = document.getElementById("reminderFox-default-doubleclick");	
	if ( defaultEditType == "todos" ) {
		defaultEdit.selectedIndex = 1; 
	}
	else {
		defaultEdit.selectedIndex = 0; 
	}
	
	
	var alertType;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
		alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	}
			
			
	var showAlert = document.getElementById("reminderFox-showAlert");	
	
	// if the user has set it to no alerts, the option should be disabled
	if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
		showAlert.setAttribute("checked", "false");	    
	}
	else {
		showAlert.setAttribute("checked", "true");	    
		
		if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 0;
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_TODAY ) {  
			document.getElementById("reminderFox-alertList").selectedIndex = 1;		
		}
		else if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING ) {  
				document.getElementById("reminderFox-alertList").selectedIndex = 2;
		}
	}
	
	var alertTimeout;
	try {
		alertTimeout = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
	} catch(e) {
	}
	document.getElementById("reminderFox-alertTimeout").setAttribute("value", alertTimeout);

	reminderFox_populateBars();
	reminderFox_populatePositions();

	alertChanged();
	groupPositionChanged();
	
}

function saveOptions() {
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"]. 
				getService(Components.interfaces.nsIPrefService). 
				getBranch(REMINDER_FOX_PREF + ".");
				
	var showStatusText =	document.getElementById("reminderFox-statustext").getAttribute("checked" );
	var showStatus;
	try {
		if ( showStatusText == "true" ) {
			showStatus = true;
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, showStatus);
		}
		else {
			showStatus = false;
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, showStatus);
		}
	} catch(e) {
	}	
	
	
	
	var showRemindersInTooltip =	document.getElementById("reminderFox-showRemindersTooltip").getAttribute("checked" );
	try {
		if ( showRemindersInTooltip == "true" ) {
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, true);
		}
		else {
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, false);
		}
	} catch(e) {
	}	
	
	var showTodosInTooltip =	document.getElementById("reminderFox-showTodosTooltip").getAttribute("checked" );
	try {
		if ( showTodosInTooltip == "true" ) {
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, true);
		}
		else {
			prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, false);
		}
	} catch(e) {
	}	
		
	
	var upcomingDays = document.getElementById("remindersUpcomingDays").value;
	try {
			prefsBranch.setCharPref(UPCOMING_REMINDER_DAYS_PREF, upcomingDays);
	} catch(e) {
	}		
	
	
	var defaultEditIndex = document.getElementById("reminderFox-default-doubleclick").selectedIndex;
	if ( defaultEditIndex == 1 ) {
			prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "todos");
	}
 	else {
 			prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, "reminders");	
 	}		
	
	var showAlert = document.getElementById("reminderFox-showAlert");	
	var showAlertVal =  showAlert.getAttribute("checked" );
	if ( showAlertVal == false  || showAlertVal == "false") {
			prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_NONE);
	}
	else {
		var alertIndex = document.getElementById("reminderFox-alertList").selectedIndex;
		if ( alertIndex == 0 ) {
				prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_ALL);
		}
		if ( alertIndex == 1 ) {
				prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_TODAY);
		}
		if ( alertIndex == 2 ) {
				prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING);
		}		
	
	}

	var alertTimeout = document.getElementById("reminderFox-alertTimeout").value;
	try {
			prefsBranch.setCharPref(REMINDER_FOX_ALERT_TIMEOUT_PREF, alertTimeout);
	} catch(e) {
	}	
	
	var position = document.getElementById("reminderFox-group-position");
	var positionText = document.getElementById("reminderFox-text-position");

    if (parseInt(position.selectedItem.value) == -1)
      prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
    else  {    
        var textPosition = document.getElementById("reminderFox-text-position");
	    if (textPosition.value < 0 || textPosition.value > reminderFox_mPositionMax) {
	      prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, -1);
	     }
	     else {
    		prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, positionText.value);
    	}      
     }
	
	
	 var toolbars = document.getElementById("reminderFox-list-bars");
	 prefsBranch.setCharPref(REMINDER_FOX_TOOLBAR, toolbars.selectedItem.value);
	
	// update all of the browsers
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);	
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");

	while (windowEnumerator.hasMoreElements()) {
		var currentWindow = windowEnumerator.getNext();		
		currentWindow.reminderFox_moveBox();
		currentWindow.reminderFox_loadReminderFox(true);			
	}
	  
	  document.getElementById("apply").setAttribute("disabled", true);

}

function updateButtons(aEvent)
{
  // don't enable the apply button for button presses
  if (aEvent) { 
    if ((aEvent.originalTarget.localName == "button") ||
        (aEvent.originalTarget.getAttribute("type") == "prof"))
    return;
  }
   
  document.getElementById("apply").removeAttribute("disabled");
}

function alertChanged() {
	var showAlert = document.getElementById("reminderFox-showAlert");	
	var showAlertVal =  showAlert.getAttribute("checked" );
	if ( showAlertVal == false || showAlertVal == "false") {
			document.getElementById("reminderFox-alertTimeout").setAttribute("disabled", "true");
			document.getElementById("reminderFox-alertList").setAttribute("disabled", "true");
			document.getElementById("showAlert1").setAttribute("disabled", "true");
			document.getElementById("showAlert2").setAttribute("disabled", "true");			
			document.getElementById("reminderFoxDisplay").setAttribute("disabled", "true");			
	}
	else {
			document.getElementById("reminderFox-alertTimeout").removeAttribute("disabled" );
			document.getElementById("reminderFox-alertList").removeAttribute("disabled" );
			document.getElementById("showAlert1").removeAttribute("disabled" );
			document.getElementById("showAlert2").removeAttribute("disabled" );
			document.getElementById("reminderFoxDisplay").removeAttribute("disabled" );
	}
	
}	


function groupPositionChanged() {
    var text = document.getElementById("reminderFox-text-position");
    var textValid = document.getElementById("reminderFox-text-position-valid");
    var group = document.getElementById("reminderFox-group-position");    
    
    if ( group.selectedIndex == 0 ) {
    	text.setAttribute("disabled", "true");
    	textValid.setAttribute("disabled", "true");    
    }
    else {
    	text.removeAttribute("disabled" );
    	textValid.removeAttribute("disabled" );
    }
}	
function exportReminders() { 
    //get file
    var file = filePicker(0, window);
    if (!file)
      return;

   var newline;
   if (navigator.appVersion.lastIndexOf('Win') != -1) {
	      newline="\r\n";
     }
	else {
		newline="\n"
	}
	var outputStr = "ReminderFox " + REMINDER_FOX_MIGRATED_PREF_VERSION +newline + newline;
	
	// collect reminders to write out
	var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
	if (reminders != "") {	
		outputStr = outputStr + "<Reminders>" + newline;
		var remindersArray = reminders.split(REMINDER_SEPARATOR);
		for(i = 0; i < remindersArray.length; i++) {
			var reminder = remindersArray[i];			
			var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
			// change month offset to 1-based so it's more human readable/editable
			var month = reminderArray[0];
			if ( month  != REMINDER_FOX_MONTHLY_WILDCARD_STR   ) { 
				month = parseInt(reminderArray[0]) + 1;
			}			
			var newReminder = month;;
			for ( var j=1; j < reminderArray.length; j++ ) {
				newReminder = newReminder + REMINDER_PROPERTY_DELIMITER +  reminderArray[j];
			}
						
			outputStr = outputStr + newReminder + newline;
		} 
	}
	
	// collect todos to write out
	var todos = reminderFox_prefs.getCharPref(REMINDER_FOX_TODOS);
	if ( todos != "" ) {
		outputStr = outputStr + newline + "<ToDo's>" + newline;
		var todosArray = todos.split(REMINDER_SEPARATOR);
		for(i = 0; i < todosArray.length; i++) {
			var todo = todosArray[i];
			outputStr = outputStr + todo + newline;
		}
	}
		
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );

	outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
	
	var result = outputStream.write( outputStr, outputStr.length );
	outputStream.close();		

	// show success message
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
	promptService.alert(window,"Success",	  "Your reminders and ToDo's have been successfully exported." );
	
	
      
}	

function importReminders() {
    var overWrite = false;
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);

	var flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
  	 	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 + 
   		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2;
	var msg =  "How do you want to import your reminders and ToDo's?\n" +
		"'Add' will add the imported items to your current existing list of reminders and ToDo's (duplicates will be ignored).\n" +
		"'Overwrite' will erase all existing reminders and ToDo's and replace them with the imported items.";
	var buttonPressed = promptService.confirmEx(window,"Add or overwrite?",
	  msg,
	  flags, "Add", "Cancel", "Overwrite", null, {});		  
	  

	// cancel pressed
	if (  buttonPressed == 1 ) {
		return ;
	}
	// overwrite pressed
	if ( buttonPressed == 2 ) {	
		// make sure they REAAAAALY want to overwrite
		var flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   			promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
		var msg =  "Are you sure you want to overwrite?  All of your existing Reminders and ToDo's will be lost and overwritten by the imported items.";
		var buttonPressed = promptService.confirmEx(window,"Overwrite Reminders and ToDo's?",
		  msg,
		  flags, "Overwrite", "Cancel", null, null, {});		  
		  
		// cancel pressed
		if ( buttonPressed == 1 ) {	
			return;
		}	
		overWrite = true;
   }     
        
    //get file
    var file = filePicker(1, window);
    if (!file)
      return;

	var newline;
   if (navigator.appVersion.lastIndexOf('Win') != -1) {
	      newline="\r\n";
     }
	else {
		newline="\n"
	}
				
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to read file was denied.");
	}

	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance( Components.interfaces.nsIFileInputStream );
	is.init( file,0x01, 00004, null);
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
		.createInstance( Components.interfaces.nsIScriptableInputStream );
	sis.init( is );
	var output = sis.read( sis.available() );
	
	var reminders = "";
	var remindersArray = output.split(newline);
	var index = 0;
	var readIn = remindersArray[index];

	// bypass header 
	while ( index < remindersArray.length && readIn != "<Reminders>" && readIn != "<ToDo's>" ) {
		index++;
		readIn = remindersArray[index];
	}
	
	// read in reminders
	if ( readIn == "<Reminders>" ) {
		index++;
		reminder = readIn;
		for(index; reminder != "" && reminder != "<ToDo's>" && index< remindersArray.length; index++) {
			var reminder = remindersArray[index];
			if ( reminder != "" &&  reminder != "<ToDo's>" ) {
				reminders = reminders + reminder + REMINDER_SEPARATOR;
			}
			else {
				readIn =reminder;
				break;
			}
		}
		// remove trailing separator char
		if ( reminders.lastIndexOf( REMINDER_SEPARATOR ) == reminders.length -1 ) {
			reminders = reminders.substring( 0, reminders.length - 1 );
		} 
	}
	
	// bypass header info
	while ( index < remindersArray.length && readIn != "<Reminders>" && readIn != "<ToDo's>" ) {
		index++;
		readIn = remindersArray[index];
	}
	
	// read in  todos
	var todos= "";
	if ( readIn == "<ToDo's>" ) {
		index++;
		var todo = readIn;
		for(index; todo != "" && index< remindersArray.length; index++) {
			todo = remindersArray[index];
			if ( todo != "" ) {
				todos = todos + todo + REMINDER_SEPARATOR;
			}
		}
		// remove trailing separator char
		if ( todos.lastIndexOf( REMINDER_SEPARATOR ) == todos.length -1 ) {
			todos = todos.substring( 0, todos.length - 1 );
		} 
	}
	sis.close();

	// parse reminders
	var newReminders = "";
	 if ( !overWrite) {
		newReminders =  reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
	}
	if ( reminders != "" ) {
		var remindersArray = reminders.split(REMINDER_SEPARATOR);
		for(i = 0; i < remindersArray.length; i++) {
			var reminder = remindersArray[i];			
			var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
			
			// account for 1-based offset stored in imported file
			var month = reminderArray[0];
			if ( month  != REMINDER_FOX_MONTHLY_WILDCARD_STR   ) { 
				month = parseInt(reminderArray[0]) - 1;
			}
			
			var newReminder = month;;
			for ( var j=1; j < reminderArray.length; j++ ) {
				newReminder = newReminder + REMINDER_PROPERTY_DELIMITER +  reminderArray[j];
			}
			
			var dayAsInteger = parseInt( reminderArray[1] );
			newReminders = reminderFox_sortNewReminder( newReminders, newReminder, month, dayAsInteger, true );
		}
	}
	
	// parse todos
	var newTodos = "";
	 if ( !overWrite) {
		newTodos =  reminderFox_prefs.getCharPref(REMINDER_FOX_TODOS);
		if ( todos != "" ) {
			var todosArray = todos.split(REMINDER_SEPARATOR);
			for(i = 0; i < todosArray.length; i++) {
				var todo = todosArray[i];
				
				if ( todo == newTodos || 
					 newTodos.indexOf( todo + REMINDER_SEPARATOR ) != -1  || 
				     newTodos.indexOf( todo + REMINDER_PROPERTY_DELIMITER ) != -1 || 
					 newTodos.indexOf( REMINDER_SEPARATOR + todo  ) != -1  ) {
					 // the todo already exists - do nothing
				}
				else {
						newTodos = reminderFox_sortNewTodo( newTodos, todo );
				}
			}
		}
	}
	else { 
		// overwrite set - just set newtodos as the value
		newTodos = todos;
	}

	reminderFox_prefs.setCharPref(REMINDER_FOX_REMINDERS, newReminders);
	reminderFox_prefs.setCharPref(REMINDER_FOX_TODOS, newTodos);
      
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
	promptService.alert(window,"Success",	  "Your reminders and ToDo's have been successfully imported." );
      
}	

function filePicker(aOpen, aWindow) {
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);  
    picker.appendFilters( nsIFilePicker.filterText | nsIFilePicker.filterAll );
    picker.filterIndex=1;
    picker.defaultExtension = ".txt";
    switch (aOpen) {
      case 0:
        picker.init(aWindow, "Export Reminders and ToDo's", nsIFilePicker.modeSave);
        break;
      case 1:
        picker.init(aWindow, "Import Reminders and ToDo's", nsIFilePicker.modeOpen);
        break;
    };
    
    // get the file and its contents
    var res = picker.show();
    if (res == nsIFilePicker.returnCancel)
      return null;
    else
      return picker.file;
}	


function concat(c1, c2)
{
  // Concats two collections into an array.
  var c3 = new Array(c1.length + c2.length);
  var x,y = 0;

  for (x = 0; x < c1.length; x++)
    c3[y++] = c1[x];

  for (x = 0; x < c2.length; x++)
    c3[y++] = c2[x];

  return c3;
}

function  reminderFox_populateBars()  {
    // Creates the menuitems for the toolbar selector.
    var win = reminderFox_getWindow();
    var toolbars = win.document.getElementsByTagName("toolbar");
    var statusbars = win.document.getElementsByTagName("statusbar");
    var menubars = win.document.getElementsByTagName("menubar");
    var popup = document.getElementById("reminderFox-popup-bars");
    var x, bar, item, val, list;
    
    // first remove the toolbars already there...
    while (popup.hasChildNodes())
      popup.removeChild(popup.firstChild);
          
    toolbars = concat(toolbars, statusbars);
    toolbars = concat(toolbars, menubars);
    for (x=0; x<toolbars.length; x++) {
      bar = toolbars[x];
      
      //do not include find toolbar
      if (bar.getAttribute("id") == "FindToolbar")
        continue;
             
      item = document.createElement("menuitem");
      item.setAttribute("id", bar.getAttribute("id"));
      item.value = bar.getAttribute("id");         
      if (bar.hasAttribute("toolbarname"))
        item.setAttribute("label", bar.getAttribute("toolbarname"));
      else
        item.setAttribute("label", bar.getAttribute("id"));                 
      popup.appendChild(item);
    }
    
    setElement("reminderFox-list-bars", "general.bar", "Char", "reminderFox-popup-bars");    
  }

  function reminderFox_populatePositions()   {
    var barid = document.getElementById("reminderFox-list-bars").selectedItem.getAttribute("id");
    var win = reminderFox_getWindow();
    var bar = win.document.getElementById(barid);

    if (!bar)
      reminderFox_mPositionMax = 0;
    else {
      var len = bar.childNodes.length;
    
      //don't include ourself in count
      if (win.document.getElementById("reminderFox-statusLabel").parentNode == bar)
        len--;
    
      reminderFox_mPositionMax = len;
        
    }

    var val;
	try {
		val = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION);
	} catch(e) {
		val = -1;
	}		

    var val2 = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    var text = document.getElementById("reminderFox-text-position");
    var radio = document.getElementsByAttribute("group", "position");
    var group = document.getElementById("reminderFox-group-position");
    var x, el;
    
    //set max value
    text.value = reminderFox_mPositionMax;
    
    //mark always last
    if (val == -1) {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) == val) {
          group.selectedItem = radio[x];
          break;
        }
      }
    }
    
    //mark specific position
    else {
      for (x=0; x < radio.length; x++) {
        if (parseInt(radio[x].value) != -1) {
          group.selectedItem = radio[x];
          break;
        }
      }    
      if (barid != val2) {
        text.value = reminderFox_mPositionMax;
      } else {
        if (val < 0)
          text.value = reminderFox_mPositionMax;
        else if (val > reminderFox_mPositionMax)
          text.value = 0;
        else
          text.value = val; 
      }
    }
    
    // update the error label
    el = document.getElementById("reminderFox-text-position-valid");
    el.setAttribute("value", "(0-"+reminderFox_mPositionMax+")");
    
    //revalidate position
//    setTimeout("gOptions.validate()", 5);
  }
  
  function  reminderFox_getWindow()  {
    //XXX may need to change this code if main window of a supported app is not "navigator:browser"
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var top = wm.getMostRecentWindow("navigator:browser");
    if (!top) {
    
    var guid;
          try {
        var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);    
        guid = app.ID;
      } catch(e) {
        var appBranch = prefService.getBranch(null);
        try {
          guid = appBranch.getCharPref("app.id");
        } catch(e) {
          guid = "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}";
        };    
      };
    
      switch (guid) {
        case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
        case "{3db10fab-e461-4c80-8b97-957ad5f8ea47}":
        default:        
          top = ww.openWindow(null, "chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
        case "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
          top = ww.openWindow(null, "chrome://navigator/content/navigator.xul", "_blank", "chrome,all,dialog=no", "about:blank");
          break;
      };
    };
    return top;  
  }
  
  
    function setElement(aName, aPref, aType, aGroup)  {
    var x, el, els, val;
    
    el = document.getElementById(aName);
    
    val = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
    //val = eval("this.mBranch.get" + aType + "Pref('" + aPref + "')");
    switch (el.localName) {
      case "checkbox":
        el.checked = val;
        break;
      case "textbox":
        el.value = val;
        break;
      case "menulist":
        els = document.getElementById(aGroup).childNodes;        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;            
      case "radiogroup":
        els = document.getElementsByAttribute("group", aGroup);        
        for (x=0; x < els.length; x++) {
          if (((aType == "Int") ? parseInt(els[x].value) : els[x].value) == val) {
            el.selectedItem = els[x];
            break;
          }
        }      
        break;
    }  
  }
  

